<style>
    code 	{	margin-bottom:10px;border:1px solid black;background-color:#777;color:white;padding:5px;display:inline-block;}
    code strong { color:#DDAA00;}
	p 		{	text-align:justify;margin-bottom:5px;}
	h3		{	font-size: 1.2em;margin:10px 0 5px 0;color:#AA3388;}
	h4		{	margin:10px 0 5px 0;text-decoration:underline;}
	ul 		{	margin-left:15px;margin-bottom:5px;}
</style>

<h2>plnStaticPages</h2>

<h3>Présentation</h3>

<p>Le plugin plnStaticPages permet de fournir un service de gestion de pages statiques à d'autres plugins, il est donc exclusivement à 
	destination des développeurs de plugins.</p>

<p>Dès qu'un de vos plugins a besoin d'afficher des informations côté "site publique", et que vous auriez bien aimé pouvoir passer par une
	émulation de type "page statique", alors plnStaticPages est l'outil idéal pour atteindre cet objectif sans avoir besoin de décortiquer
	le code de pluXml pour comprendre comment "tricher" pour créer cette page statique. plnStaticPages "triche" pour vous et gère tout cela
	pour vous.</p>

<p>Ce module technique n'a aucun intérêt dans un autre cadre que l'émulation de pages statiques</p>

<h3>Avantages et inconvénients</h3>

<p>L'avantage du plugin est bien entendu de déporter toute la gestion des pages statiques en dehors de votre plugin et de vous permettre de vous
	concentrer sur les fonctionnalités de votre plugin. plnStaticPages étant spécialisé dans la gestion des pages statiques, il se 
	veut également aussi propre que possible et n'oublie normalement rien : l'intégration au moteur de pluXml est donc optimale.</p>

<p>(si vous avez des suggestions pour améliorer encore le plugin, n'hésitez pas !)</p>

<p>Il y a cependant un inconvénient, évident mais à souligner : votre plugin devient dépend de plnStaticPages : dès qu'un utilisateur veut
	installer votre plugin, il doit d'abord installer plnStaticPages. Cela peut être roboratif pour certains d'entre vous ! Si tel est le cas,
	je vous invite à utiliser plnStaticPages comme simple source d'inspiration pour intégrer les pages statiques dans votre plugin.</p>

<h3>Fonctionnalités</h4>

<p>plnStaticPages permet de déclarer des "fausses pages statiques" accompagnées d'un trigger, qui sera considéré comme l'identifiant unique
	de la page statique. Ce trigger est celui déclenchant automatiquement l'affichage de la page statique lorsqu'il est récupéré dans l'URL
	(sur le principe <a href="" nofollow>index.php?trigger</a>).

<p>plnStaticPages peut ensuite s'appuyer sur deux façons différentes d'afficher effectivement le contenu de la pages statique : ou bien en
	faisant appel à une méthode (publique) de votre plugin, ou bien en chargeant le contenu d'un fichier se trouvant dans votre répertoire
	de plugin.</p>

<p>plnStaticPages fournit également la possibilité de modifier le titre de la page statique et celui de la barre du navigateur</p>

<p>Le choix du template de page statique à utiliser est aussi à votre main</p>

<p>Finalement, plnStaticPages offre la possibilité d'ajouter un lien vers votre page statique dans la barre de navigation de pluXml</p>

<h3>Comment l'utiliser ?</h3>

<p><strong>Très important</strong>&nbsp;: Le plugin plnStaticPages doit être chargé <strong>après</strong> tout plugin y faisant appel, 
	dans la page des plugins (ordre de chargement), le plus simple étant de le charger en dernier. C'est une manipulation qui devra également 
	être effectuée par tout utilisateur de votre plugin (il devra installer les deux plugins et charger plnStaticPages en dernier).</p>

<p>plnStaticPages met deux méthodes statiques à votre disposition :<p>

<code>
	plnStaticPages::<strong>newStaticPage</strong>($class,$trigger,$staticTitle='',$pageTitle='',$method='',$navLink='',$template='');<br/>
	plnStaticPages::<strong>setField</strong>($trigger,$field,$value);
</code>

<h4>newStaticPage</h4>

<p>la méthode newStaticPage doit être appelée avant le passage dans le hook plxMotorPreChauffageBegin de plnStaticPages. Etant chargé en 
	dernier, cela revient à faire cet appel dans le hook plxMotorPreChauffageBegin de votre plugin.</p>

<p>Cette méthode requiert deux informations obligatoires : la classe de votre plugin ainsi que le trigger associé à la page statique que
	vous voulez déclarer. Cela permet notamment de déclarer autant de pages statiques que vous le souhaitez.</p>

<p>Les autres informations sont facultatives et peuvent être fournies plus tard dans l'éxécution du plugin, à l'aide de la méthode setField.</p>

<h4>setField</h4>

<p>La méthode setField permet de définir ou modifier une information liée à une page statique déclarée. Elle doit être appelée avant le passage
	dans le hook plxShowConstruct du plugin plnStaticPage.</p>

<p>Il faut fournir à setField le trigger de la page statique à modifier, puis le champ et la valeur du champ à modifier.</p>

<p>Voici les champs possibles :</p>
<ul>
	<li><strong>staticTitle</strong>&nbsp;: le titre de la page statique, qui apparaitra donc en entête de la page statique,</li>
	<li><strong>pageTitle</strong>&nbsp;:le titre de la page html, qui apparaitra notamment dans la barre du navigateur,</li>
	<li><strong>method</strong>&nbsp;: la méthode (callback) de votre plugin à appeler pour le corps de la page statique,</li>
	<li><strong>navLink</strong>&nbsp;: si fourni, permet d'ajouter un lien dans la barre de navigation de pluXml,</li>
	<li><strong>template</strong>&nbsp;: permet de définir le template du thème à utiliser. Par défaut : static.php</li>
</ul>
<p>Aucune de ces données n'est obligatoire. Il est à noter que si la méthode (callback) n'est pas fournie, alors le plugin tentera
de se rabattre sur le fichier suivant&nbsp;:</p>
<code>./plugins/CLASSEDEVOTREPLUGIN/TRIGGER.CLASSEDEVOTREPLUGIN.php</code>

<h3>Exemples</h3>

<p>Dans les exemples suivants, nous considérerons que vous avez chargé le plugin plnStaticPages en dernière position et que
votre plugin se nomme MonZouliPlugin.</p>

<h4>Déclaration de la page statique</h4>

<p>Dans votre plugin préféré, ajouter la commande suivante dans le hook <strong>plxMotorPreChauffageBegin</strong> &nbsp;:</p>

<code>plnStaticPages::newStaticPage("MonZouliPlugin","CeciEstUnTest","Titre de ma page statique","Titre dans la barre de navigation",'','NavBarre');</code>

<p>Allez côté site : un nouveau bouton intitulé "NavBarre" est apparu dans la barre de navigation. Cliquez dessus : la page statique 
	tente de se charger. En l'occurrence, les deux titres apparaissent bien (l'un dans la page, l'autre dans la barre du navigateur).
	En regardant l'URL de plus près, on voit bien le trigger dans <a href="">index.php?CeciEstUnTest</a>.</p>

<p>Normalement, un message d'erreur apparait, indiquant que "la page est en cours de rédaction". C'est le message standard de pluXml
	lorsque le fichier qu'on tente d'accéder n'existe pas. Et comme on n'a pas encore prévu le corps de la page statique, il est 
	logique que pluXml n'arrive pas à l'afficher...</p>

<h4>Le contenu est dans un fichier</h4>

<p>A présent, dans votre répertoire de plugin (MonZouliPlugin) créez un fichier nommé :</p>

<code>CeciEstUnTest.MonZouliPlugin.php</code>

<p>Dedans, mettez le texte suivant :</p>

<code>Alors là, ça marche trop bien !</code>

<p>Vérifiez que les droits d'accès de ce fichier sont corrects, puis rechargez la page de votre navigateur. Hé ! Mais ça marche !</p>

<h4>Le contenu est dans une méthode de mon plugin</h4>

<p>Bon, si vous n'avez pas envie de créer un fichier pour gérer votre page statique, et que tout se trouve dans une méthode de votre
	plugin, il suffit de renseigner le champ "method". Vous pouvez le faire ou bien en éditant l'appel à newStaticPage, ou bien en
	utilisant la fonction dédiée à cela : setField. Cela peut notamment être utile si la méthode à appeler est fonction de certains 
	événements se déclenchant entre plxMotorPreChauffageBegin et plxShowConstruct.</p>

<p>Dans le hook plxShowConstruct, par exemple, ajoutez la commande suivante :</p>

<code>plnStaticPages::setField("CeciEstUnTest","method","TestAffichage");</code>

<p>Ajoutez également la méthode suivante à votre plugin :</p>

<code>public function TestAffichage() {echo 'Hé mais ça aussi, ça marche trop bien !';}</code>

<p>Rechargez la page... Alors, ça pête, hein ? </p>